; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\oleaut32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\oleaut32.lib

    include \masm32\macros\macros.asm

    include macros2.asm
; 
    .data
        lpString1  dd 0
        lpString2  dd 0
    .code
; 
start:
; 
    STRLENGTH EQU 1048576 * 4
    LOOPCOUNT EQU 1

    mov lpString1, alloc$(STRLENGTH)
    mov lpString2, alloc$(STRLENGTH)

    print chr$("rep movsd                  : ")
    clockctr_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
      mov   esi, lpString1
      mov   edi, lpString2
      mov   ecx, STRLENGTH SHR 2
      cld
      rep   movsd
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    print chr$("move through reg32 in loop : ")
    clockctr_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
      
      mov   esi, lpString1
      mov   edi, lpString2
      mov   ecx, STRLENGTH SHR 2
    @@:
      mov   eax, [esi]
      mov   [edi], eax
      add   esi, 4
      add   edi, 4
      sub   ecx, 1
      jnz   @B
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    print chr$("stack auto-increment       : ")
    clockctr_begin LOOPCOUNT, REALTIME_PRIORITY_CLASS
      mov   esi, lpString1
      mov   edi, lpString2
      mov   ecx, STRLENGTH SHR 2
      xchg  esi, esp
    @@:
      pop   [edi]
      add   edi, 4
      sub   ecx, 1
      jnz   @B
      xchg  esi, esp
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    free$ lpString1
    free$ lpString2
    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
